| Flutter Linux Embedder |

Functions
fl_view_accessible.h File Reference
`#include <atk/atk.h>`
`#include "flutter/shell/platform/embedder/embedder.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_engine.h"`

Go to the source code of this file.

## Functions
G_BEGIN_DECLS | G_DECLARE_FINAL_TYPE (FlViewAccessible, fl_view_accessible, FL, VIEW_ACCESSIBLE, AtkPlug) FlViewAccessible *fl_view_accessible_new(FlEngine *engine)
void | fl_view_accessible_handle_update_semantics (FlViewAccessible *accessible, const FlutterSemanticsUpdate2 *update)

## Function Documentation

## ◆ fl_view_accessible_handle_update_semantics()

void fl_view_accessible_handle_update_semantics | ( | FlViewAccessible * | accessible,
|  | const FlutterSemanticsUpdate2 * | update
| ) |  |

fl_view_accessible_handle_update_semantics: @accessible: an #FlViewAccessible. @update: semantic update information.

Handle a semantics update from Flutter.

Definition at line 142 of file fl_view_accessible.cc.

144 {
145 g_autoptr(GHashTable) pending_children =
146 g_hash_table_new_full(g_direct_hash, g_direct_equal, nullptr,
147 reinterpret_cast<GDestroyNotify>(fl_value_unref));
148 for (size_t i = 0; i < update->node_count; i++) {
149 FlutterSemanticsNode2* node = update->nodes[i];
150 FlAccessibleNode* atk_node = get_node(self, node);
151
152 fl_accessible_node_set_flags(atk_node, node->flags);
153 fl_accessible_node_set_actions(atk_node, node->actions);
154 fl_accessible_node_set_name(atk_node, node->label);
155 fl_accessible_node_set_extents(
156 atk_node, node->rect.left + node->transform.transX,
157 node->rect.top + node->transform.transY,
158 node->rect.right - node->rect.left, node->rect.bottom - node->rect.top);
159 fl_accessible_node_set_value(atk_node, node->value);
160 fl_accessible_node_set_text_selection(atk_node, node->text_selection_base,
161 node->text_selection_extent);
162 fl_accessible_node_set_text_direction(atk_node, node->text_direction);
163
164 FlValue* children = fl_value_new_int32_list(
165 node->children_in_traversal_order, node->child_count);
166 g_hash_table_insert(pending_children, atk_node, children);
167 }
168
169 g_hash_table_foreach_remove(
170 pending_children,
171 [](gpointer key, gpointer value, gpointer user_data) -> gboolean {
172 FlViewAccessible* self = FL_VIEW_ACCESSIBLE(user_data);
173
174 FlAccessibleNode* parent = FL_ACCESSIBLE_NODE(key);
175
176 size_t child_count = fl_value_get_length(static_cast<FlValue*>(value));
177 const int32_t* children_in_traversal_order =
178 fl_value_get_int32_list(static_cast<FlValue*>(value));
179
180 g_autoptr(GPtrArray) children = g_ptr_array_new();
181 for (size_t i = 0; i < child_count; i++) {
182 FlAccessibleNode* child =
183 lookup_node(self, children_in_traversal_order[i]);
184 g_assert(child != nullptr);
185 fl_accessible_node_set_parent(child, ATK_OBJECT(parent), i);
186 g_ptr_array_add(children, child);
187 }
188 fl_accessible_node_set_children(parent, children);
189
190 return TRUE;
191 },
192 self);
193 }

References fl_accessible_node_set_actions(), fl_accessible_node_set_children(), fl_accessible_node_set_extents(), fl_accessible_node_set_flags(), fl_accessible_node_set_name(), fl_accessible_node_set_parent(), fl_accessible_node_set_text_direction(), fl_accessible_node_set_text_selection(), fl_accessible_node_set_value(), fl_value_get_int32_list(), fl_value_get_length(), fl_value_new_int32_list(), fl_value_unref(), get_node(), i, lookup_node(), TRUE, user_data, and value.

Referenced by TEST(), and update_semantics_cb().

## ◆ G_DECLARE_FINAL_TYPE()

G_BEGIN_DECLS G_DECLARE_FINAL_TYPE | ( | FlViewAccessible | ,
|  | fl_view_accessible | ,
|  | FL | ,
|  | VIEW_ACCESSIBLE | ,
|  | AtkPlug |
| ) |  |

FlViewAccessible:

#FlViewAccessible is an object that exposes accessibility information for an #FlView. fl_view_accessible_new:

Creates a new accessibility object that exposes Flutter accessibility information to ATK.

Returns: a new #FlViewAccessible.

fl_value_get_int32_list
const G_MODULE_EXPORT int32_t * fl_value_get_int32_list(FlValue *self)
Definition: fl_value.cc:696
get_node
static FlAccessibleNode * get_node(FlViewAccessible *self, FlutterSemanticsNode2 *semantics)
Definition: fl_view_accessible.cc:45
fl_accessible_node_set_text_selection
void fl_accessible_node_set_text_selection(FlAccessibleNode *self, gint base, gint extent)
Definition: fl_accessible_node.cc:563
fl_accessible_node_set_flags
void fl_accessible_node_set_flags(FlAccessibleNode *self, FlutterSemanticsFlag flags)
Definition: fl_accessible_node.cc:543
fl_accessible_node_set_parent
void fl_accessible_node_set_parent(FlAccessibleNode *self, AtkObject *parent, gint index)
Definition: fl_accessible_node.cc:488
i
int i
Definition: fl_socket_accessible.cc:18
FlValue
typedefG_BEGIN_DECLS struct _FlValue FlValue
Definition: fl_value.h:42
user_data
FlKeyEvent uint64_t FlKeyResponderAsyncCallback gpointer user_data
Definition: fl_key_channel_responder.cc:121
fl_accessible_node_set_children
void fl_accessible_node_set_children(FlAccessibleNode *self, GPtrArray *children)
Definition: fl_accessible_node.cc:499
fl_value_unref
G_MODULE_EXPORT void fl_value_unref(FlValue *self)
Definition: fl_value.cc:400
fl_accessible_node_set_extents
void fl_accessible_node_set_extents(FlAccessibleNode *self, gint x, gint y, gint width, gint height)
Definition: fl_accessible_node.cc:532
fl_accessible_node_set_text_direction
void fl_accessible_node_set_text_direction(FlAccessibleNode *self, FlutterTextDirection direction)
Definition: fl_accessible_node.cc:572
TRUE
return TRUE
Definition: fl_pixel_buffer_texture_test.cc:53
fl_accessible_node_set_value
void fl_accessible_node_set_value(FlAccessibleNode *self, const gchar *value)
Definition: fl_accessible_node.cc:557
fl_value_new_int32_list
G_MODULE_EXPORT FlValue * fl_value_new_int32_list(const int32_t *data, size_t data_length)
Definition: fl_value.cc:309
fl_value_get_length
G_MODULE_EXPORT size_t fl_value_get_length(FlValue *self)
Definition: fl_value.cc:724
fl_accessible_node_set_name
void fl_accessible_node_set_name(FlAccessibleNode *self, const gchar *name)
Definition: fl_accessible_node.cc:526
fl_accessible_node_set_actions
void fl_accessible_node_set_actions(FlAccessibleNode *self, FlutterSemanticsAction actions)
Definition: fl_accessible_node.cc:550
value
uint8_t value
Definition: fl_standard_message_codec.cc:36
lookup_node
static FlAccessibleNode * lookup_node(FlViewAccessible *self, int32_t id)
Definition: fl_view_accessible.cc:38